
[This is ./Spiderweb/PROBLEMS.c++, consisting of the pertinent portions 
 of a couple of letters cc'd to the Unix TeX distribution.  If any of 
 you can help with a solution, please get in touch with Hari Dudani and
 Norman Ramsey (e-mail addresses given below); and please keep us updated
 either by phone (206-543-6259) or via e-mail (mackay@cs.washington.edu,
 elisabet@max.u.washington.edu).  Thanks!
	 --Unix TeX Distribution, April 1991.]

Subj:	SpiderWeb & C++

We have been using SpiderWeb for C++ programs for sometime and have
found some problems with it.  We are using C++ version 2.0 language
and perhaps, some problems are due to this: the Web C++ that we got
may have been a pre-2.0 version.  A list of important problems is
presented below.

...

List of problems:
=================

1.  When a user-defined data type is used in a function prototype,
    there is no space between the type name and its argument.

    For example, 

    void Classname::membername(int xxx, List& object)  

    There is no space between `&' and `object'.

2.  Default values in a function prototype make the formatting go
    crazy.

    Example:
    
    class x {
        member (int x = 0.0, int y = 0.0);
    };

3.  In a member declaration, if there are more than one `const' argument,
    the keyword `const' and its argument are not spaced properly.
    
    Example:

    class Y {
      member (const float, const float);
    }; 

4.  A class with pure virtual or const member functions is not formatted 
    correctly.
 
    Example:

    class A {
      virtual mem1 () = 0;	// pure virtual function
      member (int arg) const;   // const function 
    }

...

Thanks.

Hari Dudani
hari@atc.com

=============================================================================
From:	IN%"nr@Princeton.EDU"  "Norman Ramsey" 19-FEB-1991 10:38
Subj:	RE:  SpiderWeb & C++

...

I'm sorry to disappoint you, but all I can do is refer you to the C++
grammar, which Ed Kademan very kindly provided.  The Spider manual
explains the constructs used to write the grammar.  The C grammar was
by far the most difficult of the ones I wrote, and I am not surprised
to learn of problems with the C++ grammar.

... If you fix these problems, I hope you will send me a copy of the 
new C++ grammar, so I can share the fixes with other users.

...

Norman

==================================== EOF ====================================